﻿using System;

class A {
	protected int x = 11;

	public A() {
		m();
	}

	public virtual void m() {
		Console.WriteLine("virtual A.m: x == {0}", x);
	}
}

class B : A {	
	private int y = 22;
	private double z;

	public B() {
		z = Math.Sin(Math.PI);
	}

	public override void m() {
		Console.WriteLine("override B.m: x == {0}, y == {1}, z == {2}", x, y, z);
	}
}

class Program {
	static void Main(string[] args) {
		Console.WriteLine("Main: before B b = new B() ...");
		B b = new B();
		Console.WriteLine("Main: after B b = new B() ...");

		Console.WriteLine();
		Console.WriteLine("Main: calling b.m() ...");
		b.m();
	}
}
