﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PropertiesInCSharp6 {
	class Program {

		static int A = 8;

		static int f1() {
			return A;
		}

		static int f2() => A;

		static int X => A;

		// C# 7.0
		static int Y { get => A; }

		// Autoimplemented property:
		static int Z { get; } = A; 

		static void Main(string[] args) {
			Console.WriteLine("f1: {0}", f1());
			Console.WriteLine("f2: {0}", f2());
			Console.WriteLine(" X: {0}", X);
			Console.WriteLine(" Y: {0}", Y);
			Console.WriteLine(" Z: {0}", Z);
			Console.WriteLine();

			A = 42;

			Console.WriteLine("f1: {0}", f1());
			Console.WriteLine("f2: {0}", f2());
			Console.WriteLine(" X: {0}", X);
			Console.WriteLine(" Y: {0}", Y);
			Console.WriteLine(" Z: {0}", Z);
		}
	}
}
